package de.firstdata.common.utils;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import de.firstdata.common.exception.TechnicalIPGApiException;

public class IO {

	private static final Log log = LogFactory.getLog(IO.class);

	public static byte[] getBytes(final String resource) {
		assert resource != null && resource.length() > 0;
		if (log.isDebugEnabled()) {
			log.debug("Lese die Datei: " + resource);
		}
		InputStream input = IO.class.getResourceAsStream(resource);
		try {
			if (input == null) {
				try {
					input = new FileInputStream(resource);
				} catch (final FileNotFoundException e) {
					throw new TechnicalIPGApiException("Die resource " + resource + " konnte nicht gefunden werden.", e);
				}
			}
			final byte[] bytes = new byte[input.available()];
			input.read(bytes);
			return bytes;
		} catch (final IOException e) {
			throw new TechnicalIPGApiException(e);
		} finally {
			try {
				if (input != null) {
					input.close();
				}
			} catch (final IOException e) {
				log.warn("Die Resource " + resource + " konnte nicht geschlossen werden.", e);
			}
		}
	}

	public static String getString(final String resource) {
		return new String(getBytes(resource));
	}
}
