package de.firstdata.ipg.api.client.transaction.dedirectdebit.object;

import de.firstdata.ipg.api.client.IPGApiClient;
import de.firstdata.ipg.api.client.transaction.Amount;
import de.firstdata.ipg.api.client.transaction.dedirectdebit.DEDDCreditTransaction;
import de.firstdata.ipg.api.client.transaction.dedirectdebit.DEDirectDebit;

/**
 * This class represents a <i>Credit</i> transaction and allows for setting its
 * optional attributes by calling the appropriate <code>setter</code> methods.
 * An instance of this class is created when calling
 * {@link IPGApiClient#createCreditTransaction(double, String, String, String)}.
 * 
 * @author Andreas Schmid
 */
public final class DEDDCreditTransactionObject extends DEDDTransactionObject implements DEDDCreditTransaction {

	/**
	 * creates a <i>Credit</i> transaction with the minimum set of parameters -
	 * note that you can add optional fields by calling the appropriate
	 * <code>setter</code> methods on the returned
	 * {@link DEDDCreditTransactionObject} instance
	 * 
	 */
	public DEDDCreditTransactionObject(final Amount amount, final DEDirectDebit account) {
		super("credit", amount, account, null, null, null);
	}

	/**
	 * 
	 * @param amount
	 * @param account
	 * @param hostedDataID
	 * @param hostedDataStoreID
	 * 
	 * @deprecated use DEDDCreditTransactionObject(final Amount amount, final DEDirectDebit account) and the PaymentSetter
	 */
	@Deprecated
	public DEDDCreditTransactionObject(final Amount amount, final DEDirectDebit account, final String hostedDataID, final String hostedDataStoreID) {
		super("credit", amount, account, hostedDataID, hostedDataStoreID, null);
	}

	public DEDDCreditTransactionObject(final Amount amount, final String hostedDataID, final String hostedDataStoreID) {
		super("credit", amount, null, hostedDataID, hostedDataStoreID, null);
	}
}
